/*
 --  --------------------------------------------------------------------------
 --
 --      ISERVER  -  INMOS standard file server
 --
 --      serverc.c
 --
 --      Primary server operations
 --
 --      Copyright (c) INMOS Ltd., 1988.
 --      All Rights Reserved.
 --
 --     17-July-2000
 --     Ported to LINUX
 --  --------------------------------------------------------------------------
*/



#include <stdio.h>
#include <string.h>

#include "iserver.h"

/*********************************************************************
                            SpCommand()
**********************************************************************/

PUBLIC VOID SpCommand( void )
{
   BUFFER_DECLARATIONS;
   BOOL All;
   int Size;
   BYTE *Cl;

   DEBUG(( "SP.COMMAND" ));
   INIT_BUFFERS;
   GET_BYTE( All ); DEBUG(( "%d", All ));

   Cl=  All ? RealCommandLine : DoctoredCommandLine;

   PUT_BYTE( SP_SUCCESS );
   Size = strlen( Cl );
   PUT_SLICE( Size, Cl );
   REPLY;
}


/*********************************************************************
                                SpCore()
**********************************************************************/

PUBLIC VOID SpCore( void )
{
   BUFFER_DECLARATIONS;
   INT32 Offset;
   int Off, Length;

   DEBUG(( "SP.CORE" ));
   INIT_BUFFERS;

   if (AnalyseSwitch == 0) {
         DEBUG(("not peeked"));
         PUT_BYTE(SP_ERROR);
         REPLY;
   } else {
         GET_INT32( Offset );
	 DEBUG(( "offset %ld", Offset ));
         GET_INT16( Length );
	 DEBUG(( "length %d", Length ));
         Off = (int)Offset;
         if ( (Off >= CORE_SIZE) || (Off < 0) || (Length < 0) ) {
               PUT_BYTE( SP_ERROR );
               REPLY;
         }
         if( Length + (int)Offset > CORE_SIZE ) {
               Length = CORE_SIZE - (int)Offset;
               PUT_BYTE( SP_SUCCESS );
               PUT_SLICE( Length, &CoreDump[Offset] );
               REPLY;
         } else {
               PUT_BYTE( SP_SUCCESS );
               PUT_SLICE( Length, &CoreDump[Offset] );
               REPLY;
         }
   }
}


/*********************************************************************
                                SpId()
**********************************************************************/

PUBLIC VOID SpId( void )
{
   BUFFER_DECLARATIONS;
   BYTE Version, Host, OS, Board;

   DEBUG(( "SP.ID" ));
   INIT_BUFFERS;

   Version = VERSION_ID;
   Host = HOST_ID;
   OS = OS_ID;
   Board = BOARD_ID;

   PUT_BYTE( SP_SUCCESS );
   PUT_BYTE( Version );
   PUT_BYTE( Host );
   PUT_BYTE( OS );
   PUT_BYTE( Board );
   REPLY;
}


/*********************************************************************
                                SpUnknown()
**********************************************************************/

PUBLIC VOID SpUnknown( void )
{
   BUFFER_DECLARATIONS;
   int count; /* for stupid Ultrix compiler... */
   INFO(("[Encountered unknown primary tag (%d)]\n", Tbuf[2]));
   fprintf(stderr,"[Encountered unknown primary tag (%d)]\n", Tbuf[2]);
   INIT_BUFFERS;
   PUT_BYTE( SP_UNIMPLEMENTED );
   count=OutCount; /* ultrix compiler doesn't like & of a register */
   PUT_COUNT( count );
}

/*********************************  EOF  *****************************/


